"use strict";
exports.getLineInfo = getLineInfo;
var $$whitespace$$ = require("./whitespace");

class Position {
  constructor(line, col) {
    this.line = line
    this.column = col
  }

  offset(n) {
    return new Position(this.line, this.column + n)
  }
}

class SourceLocation {
  constructor(p, start, end) {
    this.start = start
    this.end = end
    if (p.sourceFile !== null) this.source = p.sourceFile
  }
}

function getLineInfo(input, offset) {
  for (let line = 1, cur = 0;;) {
    $$whitespace$$.lineBreakG.lastIndex = cur
    let match = $$whitespace$$.lineBreakG.exec(input)
    if (match && match.index < offset) {
      ++line
      cur = match.index + match[0].length
    } else {
      return new Position(line, offset - cur)
    }
  }
}

exports.Position = Position, exports.SourceLocation = SourceLocation;